# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class ChangelistAction(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ChangelistAction - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'depot_file': 'str',
            'from_depot_file': 'str',
            'action_type': 'str',
            'content': 'str',
            'require_version': 'int'
        }

        self.attribute_map = {
            'depot_file': 'depotFile',
            'from_depot_file': 'fromDepotFile',
            'action_type': 'actionType',
            'content': 'content',
            'require_version': 'requireVersion'
        }

        self._depot_file = None
        self._from_depot_file = None
        self._action_type = None
        self._content = None
        self._require_version = None

    @property
    def depot_file(self):
        """
        Gets the depot_file of this ChangelistAction.
        The target file path to edit.

        :return: The depot_file of this ChangelistAction.
        :rtype: str
        """
        return self._depot_file

    @depot_file.setter
    def depot_file(self, depot_file):
        """
        Sets the depot_file of this ChangelistAction.
        The target file path to edit.

        :param depot_file: The depot_file of this ChangelistAction.
        :type: str
        """
        self._depot_file = depot_file

    @property
    def from_depot_file(self):
        """
        Gets the from_depot_file of this ChangelistAction.
        For \"branch\" or \"move\" actions, this indicates the source file location.

        :return: The from_depot_file of this ChangelistAction.
        :rtype: str
        """
        return self._from_depot_file

    @from_depot_file.setter
    def from_depot_file(self, from_depot_file):
        """
        Sets the from_depot_file of this ChangelistAction.
        For \"branch\" or \"move\" actions, this indicates the source file location.

        :param from_depot_file: The from_depot_file of this ChangelistAction.
        :type: str
        """
        self._from_depot_file = from_depot_file

    @property
    def action_type(self):
        """
        Gets the action_type of this ChangelistAction.
        One of \"upload\", \"branch\", \"move\", or \"delete\"

        :return: The action_type of this ChangelistAction.
        :rtype: str
        """
        return self._action_type

    @action_type.setter
    def action_type(self, action_type):
        """
        Sets the action_type of this ChangelistAction.
        One of \"upload\", \"branch\", \"move\", or \"delete\"

        :param action_type: The action_type of this ChangelistAction.
        :type: str
        """
        self._action_type = action_type

    @property
    def content(self):
        """
        Gets the content of this ChangelistAction.
        Base64-encoded content

        :return: The content of this ChangelistAction.
        :rtype: str
        """
        return self._content

    @content.setter
    def content(self, content):
        """
        Sets the content of this ChangelistAction.
        Base64-encoded content

        :param content: The content of this ChangelistAction.
        :type: str
        """
        self._content = content

    @property
    def require_version(self):
        """
        Gets the require_version of this ChangelistAction.
        If set, we will only operate if this is the current version of the file.

        :return: The require_version of this ChangelistAction.
        :rtype: int
        """
        return self._require_version

    @require_version.setter
    def require_version(self, require_version):
        """
        Sets the require_version of this ChangelistAction.
        If set, we will only operate if this is the current version of the file.

        :param require_version: The require_version of this ChangelistAction.
        :type: int
        """
        self._require_version = require_version

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

