# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class ChangesCommand(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ChangesCommand - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'change': 'str',
            'date': 'datetime',
            'user': 'str',
            'client': 'str',
            'status': 'str',
            'type': 'str',
            'path': 'str',
            'description': 'str'
        }

        self.attribute_map = {
            'change': 'change',
            'date': 'date',
            'user': 'user',
            'client': 'client',
            'status': 'status',
            'type': 'type',
            'path': 'path',
            'description': 'description'
        }

        self._change = None
        self._date = None
        self._user = None
        self._client = None
        self._status = None
        self._type = None
        self._path = None
        self._description = None

    @property
    def change(self):
        """
        Gets the change of this ChangesCommand.
        The changelist ID

        :return: The change of this ChangesCommand.
        :rtype: str
        """
        return self._change

    @change.setter
    def change(self, change):
        """
        Sets the change of this ChangesCommand.
        The changelist ID

        :param change: The change of this ChangesCommand.
        :type: str
        """
        self._change = change

    @property
    def date(self):
        """
        Gets the date of this ChangesCommand.
        Last modification time of the changelist

        :return: The date of this ChangesCommand.
        :rtype: datetime
        """
        return self._date

    @date.setter
    def date(self, date):
        """
        Sets the date of this ChangesCommand.
        Last modification time of the changelist

        :param date: The date of this ChangesCommand.
        :type: datetime
        """
        self._date = date

    @property
    def user(self):
        """
        Gets the user of this ChangesCommand.
        The owner of the changelist

        :return: The user of this ChangesCommand.
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """
        Sets the user of this ChangesCommand.
        The owner of the changelist

        :param user: The user of this ChangesCommand.
        :type: str
        """
        self._user = user

    @property
    def client(self):
        """
        Gets the client of this ChangesCommand.
        Name of current client workspace.

        :return: The client of this ChangesCommand.
        :rtype: str
        """
        return self._client

    @client.setter
    def client(self, client):
        """
        Sets the client of this ChangesCommand.
        Name of current client workspace.

        :param client: The client of this ChangesCommand.
        :type: str
        """
        self._client = client

    @property
    def status(self):
        """
        Gets the status of this ChangesCommand.
        `pending`, `shelved`, `submitted`, or `new`.\nNot editable by the user.\n\nThe status is `new` when the changelist is created, `pending` when it has been created but has not yet been submitted to the depot, `shelved` when its contents are shelved, and `submitted` when its contents have been stored in the depot.

        :return: The status of this ChangesCommand.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this ChangesCommand.
        `pending`, `shelved`, `submitted`, or `new`.\nNot editable by the user.\n\nThe status is `new` when the changelist is created, `pending` when it has been created but has not yet been submitted to the depot, `shelved` when its contents are shelved, and `submitted` when its contents have been stored in the depot.

        :param status: The status of this ChangesCommand.
        :type: str
        """
        self._status = status

    @property
    def type(self):
        """
        Gets the type of this ChangesCommand.
        Type of change: `restricted` or `public`.\n\nThe Type: field can be used to hide the change or its description from users.\nA shelved or committed change (as denoted in the Status: field) that is restricted is accessible only to users who own the change or have list permission to at least one file in the change.\n\nPublic changes are displayed without restrictions.\n\nBy default, changelists are public.\nA Perforce superuser can set the default changelist type (for changelists created after the configurable is set) by setting the defaultChangeType configurable.

        :return: The type of this ChangesCommand.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this ChangesCommand.
        Type of change: `restricted` or `public`.\n\nThe Type: field can be used to hide the change or its description from users.\nA shelved or committed change (as denoted in the Status: field) that is restricted is accessible only to users who own the change or have list permission to at least one file in the change.\n\nPublic changes are displayed without restrictions.\n\nBy default, changelists are public.\nA Perforce superuser can set the default changelist type (for changelists created after the configurable is set) by setting the defaultChangeType configurable.

        :param type: The type of this ChangesCommand.
        :type: str
        """
        self._type = type

    @property
    def path(self):
        """
        Gets the path of this ChangesCommand.
        Depot paths affected by this changelist

        :return: The path of this ChangesCommand.
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """
        Sets the path of this ChangesCommand.
        Depot paths affected by this changelist

        :param path: The path of this ChangesCommand.
        :type: str
        """
        self._path = path

    @property
    def description(self):
        """
        Gets the description of this ChangesCommand.
        Textual description of changelist.\n\nIf you do not have access to a restricted changelist, the description is replaced with a \"no permission\" message.

        :return: The description of this ChangesCommand.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this ChangesCommand.
        Textual description of changelist.\n\nIf you do not have access to a restricted changelist, the description is replaced with a \"no permission\" message.

        :param description: The description of this ChangesCommand.
        :type: str
        """
        self._description = description

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

