# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class FilesCommand(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FilesCommand - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'depot_file': 'str',
            'revision': 'str',
            'change': 'str',
            'action': 'str',
            'time': 'datetime',
            'type': 'str'
        }

        self.attribute_map = {
            'depot_file': 'depotFile',
            'revision': 'revision',
            'change': 'change',
            'action': 'action',
            'time': 'time',
            'type': 'type'
        }

        self._depot_file = None
        self._revision = None
        self._change = None
        self._action = None
        self._time = None
        self._type = None

    @property
    def depot_file(self):
        """
        Gets the depot_file of this FilesCommand.


        :return: The depot_file of this FilesCommand.
        :rtype: str
        """
        return self._depot_file

    @depot_file.setter
    def depot_file(self, depot_file):
        """
        Sets the depot_file of this FilesCommand.


        :param depot_file: The depot_file of this FilesCommand.
        :type: str
        """
        self._depot_file = depot_file

    @property
    def revision(self):
        """
        Gets the revision of this FilesCommand.


        :return: The revision of this FilesCommand.
        :rtype: str
        """
        return self._revision

    @revision.setter
    def revision(self, revision):
        """
        Sets the revision of this FilesCommand.


        :param revision: The revision of this FilesCommand.
        :type: str
        """
        self._revision = revision

    @property
    def change(self):
        """
        Gets the change of this FilesCommand.


        :return: The change of this FilesCommand.
        :rtype: str
        """
        return self._change

    @change.setter
    def change(self, change):
        """
        Sets the change of this FilesCommand.


        :param change: The change of this FilesCommand.
        :type: str
        """
        self._change = change

    @property
    def action(self):
        """
        Gets the action of this FilesCommand.


        :return: The action of this FilesCommand.
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """
        Sets the action of this FilesCommand.


        :param action: The action of this FilesCommand.
        :type: str
        """
        self._action = action

    @property
    def time(self):
        """
        Gets the time of this FilesCommand.


        :return: The time of this FilesCommand.
        :rtype: datetime
        """
        return self._time

    @time.setter
    def time(self, time):
        """
        Sets the time of this FilesCommand.


        :param time: The time of this FilesCommand.
        :type: datetime
        """
        self._time = time

    @property
    def type(self):
        """
        Gets the type of this FilesCommand.


        :return: The type of this FilesCommand.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this FilesCommand.


        :param type: The type of this FilesCommand.
        :type: str
        """
        self._type = type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

