# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class GroupCommand(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        GroupCommand - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'group': 'str',
            'max_results': 'str',
            'max_scan_rows': 'str',
            'max_lock_time': 'str',
            'max_open_files': 'str',
            'timeout': 'str',
            'password_timeout': 'str',
            'ldap_config': 'str',
            'ldap_search_query': 'str',
            'ldap_user_attribute': 'str',
            'subgroups': 'list[str]',
            'owners': 'list[str]',
            'users': 'list[str]'
        }

        self.attribute_map = {
            'group': 'group',
            'max_results': 'maxResults',
            'max_scan_rows': 'maxScanRows',
            'max_lock_time': 'maxLockTime',
            'max_open_files': 'maxOpenFiles',
            'timeout': 'timeout',
            'password_timeout': 'passwordTimeout',
            'ldap_config': 'ldapConfig',
            'ldap_search_query': 'ldapSearchQuery',
            'ldap_user_attribute': 'ldapUserAttribute',
            'subgroups': 'subgroups',
            'owners': 'owners',
            'users': 'users'
        }

        self._group = None
        self._max_results = None
        self._max_scan_rows = None
        self._max_lock_time = None
        self._max_open_files = None
        self._timeout = None
        self._password_timeout = None
        self._ldap_config = None
        self._ldap_search_query = None
        self._ldap_user_attribute = None
        self._subgroups = None
        self._owners = None
        self._users = None

    @property
    def group(self):
        """
        Gets the group of this GroupCommand.
        The name of the group, as entered on the command line.

        :return: The group of this GroupCommand.
        :rtype: str
        """
        return self._group

    @group.setter
    def group(self, group):
        """
        Sets the group of this GroupCommand.
        The name of the group, as entered on the command line.

        :param group: The group of this GroupCommand.
        :type: str
        """
        self._group = group

    @property
    def max_results(self):
        """
        Gets the max_results of this GroupCommand.
        The maximum number of results that members of this group can access from the service from a single command.\nThe default value is `unset`.

        :return: The max_results of this GroupCommand.
        :rtype: str
        """
        return self._max_results

    @max_results.setter
    def max_results(self, max_results):
        """
        Sets the max_results of this GroupCommand.
        The maximum number of results that members of this group can access from the service from a single command.\nThe default value is `unset`.

        :param max_results: The max_results of this GroupCommand.
        :type: str
        """
        self._max_results = max_results

    @property
    def max_scan_rows(self):
        """
        Gets the max_scan_rows of this GroupCommand.
        The maximum number of rows that members of this group can scan from the service from a single command.\nThe default value is `unset`.

        :return: The max_scan_rows of this GroupCommand.
        :rtype: str
        """
        return self._max_scan_rows

    @max_scan_rows.setter
    def max_scan_rows(self, max_scan_rows):
        """
        Sets the max_scan_rows of this GroupCommand.
        The maximum number of rows that members of this group can scan from the service from a single command.\nThe default value is `unset`.

        :param max_scan_rows: The max_scan_rows of this GroupCommand.
        :type: str
        """
        self._max_scan_rows = max_scan_rows

    @property
    def max_lock_time(self):
        """
        Gets the max_lock_time of this GroupCommand.
        The maximum length of time (in milliseconds) that any one operation can lock any database table when scanning data.\nThe default value is `unset`.

        :return: The max_lock_time of this GroupCommand.
        :rtype: str
        """
        return self._max_lock_time

    @max_lock_time.setter
    def max_lock_time(self, max_lock_time):
        """
        Sets the max_lock_time of this GroupCommand.
        The maximum length of time (in milliseconds) that any one operation can lock any database table when scanning data.\nThe default value is `unset`.

        :param max_lock_time: The max_lock_time of this GroupCommand.
        :type: str
        """
        self._max_lock_time = max_lock_time

    @property
    def max_open_files(self):
        """
        Gets the max_open_files of this GroupCommand.
        The maximum number of files that a member of a group can open using a single command.

        :return: The max_open_files of this GroupCommand.
        :rtype: str
        """
        return self._max_open_files

    @max_open_files.setter
    def max_open_files(self, max_open_files):
        """
        Sets the max_open_files of this GroupCommand.
        The maximum number of files that a member of a group can open using a single command.

        :param max_open_files: The max_open_files of this GroupCommand.
        :type: str
        """
        self._max_open_files = max_open_files

    @property
    def timeout(self):
        """
        Gets the timeout of this GroupCommand.
        The duration (in seconds) of the validity of a session ticket created by p4 login.\nThe default value is 43,200 seconds (12 hours).\nTo create a ticket that does not expire, set the Timeout: field to `unlimited`.

        :return: The timeout of this GroupCommand.
        :rtype: str
        """
        return self._timeout

    @timeout.setter
    def timeout(self, timeout):
        """
        Sets the timeout of this GroupCommand.
        The duration (in seconds) of the validity of a session ticket created by p4 login.\nThe default value is 43,200 seconds (12 hours).\nTo create a ticket that does not expire, set the Timeout: field to `unlimited`.

        :param timeout: The timeout of this GroupCommand.
        :type: str
        """
        self._timeout = timeout

    @property
    def password_timeout(self):
        """
        Gets the password_timeout of this GroupCommand.
        The length of time (in seconds) for which passwords for users in this group remain valid.\nTo disable password aging, use a value of unset.

        :return: The password_timeout of this GroupCommand.
        :rtype: str
        """
        return self._password_timeout

    @password_timeout.setter
    def password_timeout(self, password_timeout):
        """
        Sets the password_timeout of this GroupCommand.
        The length of time (in seconds) for which passwords for users in this group remain valid.\nTo disable password aging, use a value of unset.

        :param password_timeout: The password_timeout of this GroupCommand.
        :type: str
        """
        self._password_timeout = password_timeout

    @property
    def ldap_config(self):
        """
        Gets the ldap_config of this GroupCommand.
        The LDAP configuration to use when populating the group’s user list from an LDAP query.

        :return: The ldap_config of this GroupCommand.
        :rtype: str
        """
        return self._ldap_config

    @ldap_config.setter
    def ldap_config(self, ldap_config):
        """
        Sets the ldap_config of this GroupCommand.
        The LDAP configuration to use when populating the group’s user list from an LDAP query.

        :param ldap_config: The ldap_config of this GroupCommand.
        :type: str
        """
        self._ldap_config = ldap_config

    @property
    def ldap_search_query(self):
        """
        Gets the ldap_search_query of this GroupCommand.
        The LDAP query used to identify the members of the group.

        :return: The ldap_search_query of this GroupCommand.
        :rtype: str
        """
        return self._ldap_search_query

    @ldap_search_query.setter
    def ldap_search_query(self, ldap_search_query):
        """
        Sets the ldap_search_query of this GroupCommand.
        The LDAP query used to identify the members of the group.

        :param ldap_search_query: The ldap_search_query of this GroupCommand.
        :type: str
        """
        self._ldap_search_query = ldap_search_query

    @property
    def ldap_user_attribute(self):
        """
        Gets the ldap_user_attribute of this GroupCommand.
        The LDAP attribute that represents the user’s username.

        :return: The ldap_user_attribute of this GroupCommand.
        :rtype: str
        """
        return self._ldap_user_attribute

    @ldap_user_attribute.setter
    def ldap_user_attribute(self, ldap_user_attribute):
        """
        Sets the ldap_user_attribute of this GroupCommand.
        The LDAP attribute that represents the user’s username.

        :param ldap_user_attribute: The ldap_user_attribute of this GroupCommand.
        :type: str
        """
        self._ldap_user_attribute = ldap_user_attribute

    @property
    def subgroups(self):
        """
        Gets the subgroups of this GroupCommand.
        Names of other Perforce groups.\n\nTo add all users in a previously defined group to the group you’re presently working with, include the group name in the Subgroups: field of the p4 group form.\nNote that user and group names occupy separate namespaces, and thus, groups and users can have the same names.\n\nEvery member of any previously defined group you list in the Subgroups: field will be a member of the group you’re now defining.

        :return: The subgroups of this GroupCommand.
        :rtype: list[str]
        """
        return self._subgroups

    @subgroups.setter
    def subgroups(self, subgroups):
        """
        Sets the subgroups of this GroupCommand.
        Names of other Perforce groups.\n\nTo add all users in a previously defined group to the group you’re presently working with, include the group name in the Subgroups: field of the p4 group form.\nNote that user and group names occupy separate namespaces, and thus, groups and users can have the same names.\n\nEvery member of any previously defined group you list in the Subgroups: field will be a member of the group you’re now defining.

        :param subgroups: The subgroups of this GroupCommand.
        :type: list[str]
        """
        self._subgroups = subgroups

    @property
    def owners(self):
        """
        Gets the owners of this GroupCommand.
        Names of other Perforce users.\n\n  Group owners without super access are permitted to administer this group, provided that they use the -a option.\n\n  Group owners are not necessarily members of a group; if a group owner is to be a member of the group, the userid must also be added to the Users: field.\n\n  The specified owner does not have to be a Perforce user.\n  You might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.

        :return: The owners of this GroupCommand.
        :rtype: list[str]
        """
        return self._owners

    @owners.setter
    def owners(self, owners):
        """
        Sets the owners of this GroupCommand.
        Names of other Perforce users.\n\n  Group owners without super access are permitted to administer this group, provided that they use the -a option.\n\n  Group owners are not necessarily members of a group; if a group owner is to be a member of the group, the userid must also be added to the Users: field.\n\n  The specified owner does not have to be a Perforce user.\n  You might want to use an arbitrary name if the user does not yet exist, or if you have deleted the user and need a placeholder until you can assign the spec to a new user.

        :param owners: The owners of this GroupCommand.
        :type: list[str]
        """
        self._owners = owners

    @property
    def users(self):
        """
        Gets the users of this GroupCommand.
        The Perforce usernames of the group members.

        :return: The users of this GroupCommand.
        :rtype: list[str]
        """
        return self._users

    @users.setter
    def users(self, users):
        """
        Sets the users of this GroupCommand.
        The Perforce usernames of the group members.

        :param users: The users of this GroupCommand.
        :type: list[str]
        """
        self._users = users

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

