# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class UsersCommand(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        UsersCommand - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'user': 'str',
            'type': 'str',
            'email': 'str',
            'update': 'datetime',
            'access': 'datetime',
            'full_name': 'str',
            'has_password': 'str'
        }

        self.attribute_map = {
            'user': 'user',
            'type': 'type',
            'email': 'email',
            'update': 'update',
            'access': 'access',
            'full_name': 'fullName',
            'has_password': 'hasPassword'
        }

        self._user = None
        self._type = None
        self._email = None
        self._update = None
        self._access = None
        self._full_name = None
        self._has_password = None

    @property
    def user(self):
        """
        Gets the user of this UsersCommand.
        The Perforce username.

        :return: The user of this UsersCommand.
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """
        Sets the user of this UsersCommand.
        The Perforce username.

        :param user: The user of this UsersCommand.
        :type: str
        """
        self._user = user

    @property
    def type(self):
        """
        Gets the type of this UsersCommand.
        Type of user: standard, operator, or service.\n\nOnce you set the type, you cannot change it.

        :return: The type of this UsersCommand.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this UsersCommand.
        Type of user: standard, operator, or service.\n\nOnce you set the type, you cannot change it.

        :param type: The type of this UsersCommand.
        :type: str
        """
        self._type = type

    @property
    def email(self):
        """
        Gets the email of this UsersCommand.
        The user’s email address. By default, this is user@client.

        :return: The email of this UsersCommand.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """
        Sets the email of this UsersCommand.
        The user’s email address. By default, this is user@client.

        :param email: The email of this UsersCommand.
        :type: str
        """
        self._email = email

    @property
    def update(self):
        """
        Gets the update of this UsersCommand.
        The date and time this specification was last updated.

        :return: The update of this UsersCommand.
        :rtype: datetime
        """
        return self._update

    @update.setter
    def update(self, update):
        """
        Sets the update of this UsersCommand.
        The date and time this specification was last updated.

        :param update: The update of this UsersCommand.
        :type: datetime
        """
        self._update = update

    @property
    def access(self):
        """
        Gets the access of this UsersCommand.
        The date and time this user last ran a Perforce command.

        :return: The access of this UsersCommand.
        :rtype: datetime
        """
        return self._access

    @access.setter
    def access(self, access):
        """
        Sets the access of this UsersCommand.
        The date and time this user last ran a Perforce command.

        :param access: The access of this UsersCommand.
        :type: datetime
        """
        self._access = access

    @property
    def full_name(self):
        """
        Gets the full_name of this UsersCommand.
        The user's full name.

        :return: The full_name of this UsersCommand.
        :rtype: str
        """
        return self._full_name

    @full_name.setter
    def full_name(self, full_name):
        """
        Sets the full_name of this UsersCommand.
        The user's full name.

        :param full_name: The full_name of this UsersCommand.
        :type: str
        """
        self._full_name = full_name

    @property
    def has_password(self):
        """
        Gets the has_password of this UsersCommand.
        If 'enabled', the password has been set on the user.

        :return: The has_password of this UsersCommand.
        :rtype: str
        """
        return self._has_password

    @has_password.setter
    def has_password(self, has_password):
        """
        Sets the has_password of this UsersCommand.
        If 'enabled', the password has been set on the user.

        :param has_password: The has_password of this UsersCommand.
        :type: str
        """
        self._has_password = has_password

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

