#!/usr/bin/env bash
#
# Sets up the virtual environment directory venv.
#
# On OS X we also tweak the path to make sure we can get the homebrew version of python.

if [ -f /usr/local/bin/python ]; then
    PATH=/usr/local/bin:$PATH
fi

if [ -d venv ]; then
    echo "venv already exists... delete and retry"
    exit 1
fi

virtualenv venv

source venv/bin/activate
pip install -r requirements.txt
